// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#ifndef YELLOW_BOX
// This code isn't needed on Yellow Box systems.

#import <stdlib.h>
#import <string.h>

extern char **environ;

static int putenv(const char *str)
{
    char **ptr = environ;
    char *equals;
    char **target = NULL;
    int count = 1;
    int key_length;
    char *copy;

    if (str == NULL)
        return -1;

    equals = strchr(str, '=');
    if (equals == NULL)
        return -1;

    key_length = equals - str;

    while (*ptr) {
        if (strncmp(str, *ptr, key_length) == 0)
            target = ptr;
        ptr++;
        count++;
    }

    copy = malloc(strlen(str)+1);
    if (copy == NULL)
        return -1;
    strcpy (copy, str);

    if (target == NULL) {
        char **environ_copy;

        // Add it to the environment.
        environ_copy = malloc((count + 1) * sizeof (char *));
        if (environ_copy == NULL)
            return -1;
        *environ_copy = copy;
        bcopy (environ, environ_copy + 1, count * sizeof (char *));
        environ = environ_copy;
    } else {
        // Replace the current one.
        *target = copy;
    }

    return 0;
}
#endif

#ifndef setenv
int setenv(const char *name, const char *value, int rewrite)
{
    char *buf;
    int result;

    // This isn't a full-fledged implementation:  we just ignore the rewrite flag...

    buf = malloc(strlen(name) + strlen(value) + 2);
    if (buf == NULL)
        return -1;

    strcpy(buf, name);
    strcat(buf, "=");
    strcat(buf, value);
    result = putenv(buf);
    free(buf);
    return result;
}
#endif
